package dev.shadowsoffire.apotheosis.spawn.compat;

import net.minecraft.world.level.block.Blocks;
import net.minecraft.core.BlockPos;
import snownee.jade.api.Accessor;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.network.chat.Component;
import java.util.function.Consumer;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerStats;
import java.util.Objects;
import net.minecraft.client.gui.screens.Screen;
import snownee.jade.api.config.IPluginConfig;
import snownee.jade.api.ITooltip;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerBlock;
import snownee.jade.api.IWailaClientRegistration;
import dev.shadowsoffire.apotheosis.Apotheosis;
import snownee.jade.api.IWailaCommonRegistration;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import snownee.jade.api.WailaPlugin;
import snownee.jade.api.BlockAccessor;
import snownee.jade.api.IServerDataProvider;
import snownee.jade.api.IBlockComponentProvider;
import snownee.jade.api.IWailaPlugin;

@WailaPlugin
public class SpawnerHwylaPlugin implements IWailaPlugin, IBlockComponentProvider, IServerDataProvider<BlockAccessor>
{
    private static final ApothSpawnerTile tooltipTile;
    
    public void register(final IWailaCommonRegistration reg) {
        if (Apotheosis.enableSpawner) {
            reg.registerBlockDataProvider((IServerDataProvider)this, (Class)ApothSpawnerTile.class);
        }
    }
    
    public void registerClient(final IWailaClientRegistration reg) {
        if (Apotheosis.enableSpawner) {
            reg.registerBlockComponent((IBlockComponentProvider)this, (Class)ApothSpawnerBlock.class);
        }
    }
    
    public void appendTooltip(final ITooltip tooltip, final BlockAccessor accessor, final IPluginConfig config) {
        if (Screen.m_96637_()) {
            SpawnerHwylaPlugin.tooltipTile.m_142466_(accessor.getServerData());
            final ApothSpawnerTile tooltipTile = SpawnerHwylaPlugin.tooltipTile;
            Objects.requireNonNull(tooltip);
            SpawnerStats.generateTooltip(tooltipTile, (Consumer)tooltip::add);
        }
        else {
            tooltip.add((Component)Component.m_237115_("misc.apotheosis.ctrl_stats"));
        }
    }
    
    public void appendServerData(final CompoundTag tag, final BlockAccessor access) {
        final BlockEntity blockEntity = access.getBlockEntity();
        if (blockEntity instanceof final ApothSpawnerTile spw) {
            spw.m_183515_(tag);
        }
    }
    
    public ResourceLocation getUid() {
        return Apotheosis.loc("spawner");
    }
    
    static {
        tooltipTile = new ApothSpawnerTile(BlockPos.f_121853_, Blocks.f_50016_.m_49966_());
    }
}
